/*
 *   Copyright (C) 2006 
 *   Siraj Razick <siraj@kdemail.net>
 *   PhobosK <phobosk@mail.kbfx.org>
 *   see Also ATHORS 
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef KBFX_DATA_GROUP_H
#define KBFX_DATA_GROUP_H

#include <qmap.h>
#include <qstringlist.h>
#include "kbfxdatasource.h"

class KbfxDataGroup
{

public:
	typedef QMap<QString,KbfxDataSource*> Data;
	KbfxDataGroup();
	 ~KbfxDataGroup();
	void addItem(KbfxDataSource * item);
	void setName(QString name){m_name  = name;}
	KbfxDataSource * getItem(QString);
	Data getData();
	KbfxDataSource::DataSourceList lookup(QString);
	QString name(){return m_name;}
	int count(){return m_count;}

private:
	Data m_data;
	QString m_name;
	int m_count;
};

#endif
