
#ifndef KBFX_PLASMA_INDEX_VIEW_H
#define KBFX_PLASMA_INDEX_VIEW_H

#include <qcanvas.h>
#include "kbfxdatastack.h"
#include "kbfxplasmacanvasstack.h"
#include "kbfxplasmaindexitem.h"
#include "kbfxsignal.h"
#include "kbfxplasmapluginloader.h"
#include "kbfxplasmacanvasview.h"

//KDE
#include <kpopupmenu.h>



class KbfxPlasmaIndexView : public QCanvasView
{

Q_OBJECT

public:

 KbfxPlasmaIndexView(QWidget * parent = 0, const char * name = 0, WFlags l = 0 );
 ~KbfxPlasmaIndexView();
 void loadList(KbfxDataStack * stkPtr);
	int count(){ return m_itemGroup->count() ; }
	void clearAll();
	void setView(KbfxPlasmaCanvasView * view);
	virtual void contentsMouseMoveEvent ( QMouseEvent * e );
	virtual void contentsMousePressEvent(QMouseEvent * me);	
	virtual void contentsContextMenuEvent ( QContextMenuEvent * e ) ;
	virtual void mouseMoveEvent(QMouseEvent * e);
	virtual void leaveEvent(QEvent * e);
	void setKbfxCanvas (QCanvas * cnv);

public slots:
	void slotClicked(KbfxPlasmaIndexItem *);
	void contextMenuSlot(int id);
	void loadPlugin(QString name,KbfxPlasmaCanvasView *);
	void checkMousePos();


signals:
	void loadRequest(KbfxSignal signal);
	void pluginRequest(QString pluginName,KbfxPlasmaCanvasView * );
	void clicked(KbfxPlasmaIndexItem * item);
	void expand();

protected:
	void clearAllButOne(KbfxPlasmaIndexItem * i);

private:

	KbfxPlasmaCanvasGroup * m_itemGroup;
	KbfxPlasmaCanvasGroupView * m_itemGroupList;
	KbfxPlasmaCanvasStack * m_itemStack;
	KbfxPlasmaIndexItem * m_currentItem;
	KbfxPlasmaIndexItem * m_selectedItem;
	QStringList m_pluginList; 
	QStringList m_pluginLoaded; 
	KPopupMenu * m_pluginMenu;
	KbfxPlasmaCanvasView * m_currentView;
	QPoint m_currentPos;
	QTimer  * m_mousePollTimer;
};

#endif
