/*
 *   Copyright (C) 2006 
 *   Siraj Razick <siraj@kdemail.net>
 *   PhobosK <phobosk@mail.kbfx.org>
 *   see Also ATHORS 
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef KBFX_PLASMA_LIST_BOX_H
#define KBFX_PLASMA_LIST_BOX_H

#include <qlistbox.h>
#include "kbfxplasmacanvasstack.h"
#include <kpopupmenu.h>
#include "kbfxsignal.h"
#include "kbfxdatastack.h"
#include "kbfxplasmalistboxitem.h"



class KbfxPlasmaListBox:public QListBox
{

Q_OBJECT
public:
	KbfxPlasmaListBox( QWidget * parent = 0, const char * name = 0, WFlags f = 0 );
	~KbfxPlasmaListBox();
	void loadList(KbfxPlasmaCanvasStack * stkPtr);
	void loadList(KbfxDataStack * stkPtr);
	void contentsContextMenuEvent(QContextMenuEvent *event);
	virtual void contentsMouseMoveEvent ( QMouseEvent * e ) ;
	virtual void leaveEvent (QEvent * e);
	virtual void viewportPaintEvent(QPaintEvent * e);
	virtual void keyPressEvent(QKeyEvent *  ke);
	//virtual void focusOutEvent(QFocusEvent *e ) { clearSelection () ;}
	bool findLoaded(QString);
public slots:
	void slotClicked(QListBoxItem*);
	void contextMenuSlot(int id);
	void clearItemSelection();
signals:
	void pluginRequest(QString pluginName);
	void loadRequest(KbfxSignal signal);
	void sizeChanged();

private:
	void clearAllButOne(KbfxPlasmaListBoxItem * item);//Classic hack from the older source code..hehe
	KPopupMenu * m_pluginMenu;
	QStringList m_pluginList; 
//state
	bool m_pressed;

};

#endif
