/*
 *   Copyright (C) 2006 
 *   Siraj Razick <siraj@kdemail.net>
 *   PhobosK <phobosk@mail.kbfx.org>
 *   see Also ATHORS 
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef KBFX_PLASMA_LIST_BOX_ITEM_H
#define KBFX_PLASMA_LIST_BOX_ITEM_H

#include <qlistbox.h>
#include <qobject.h>

class KbfxPlasmaListBoxItem:public QObject,public QListBoxItem
{
Q_OBJECT

public:
		KbfxPlasmaListBoxItem(QListBox * listbox = 0 );
		KbfxPlasmaListBoxItem();
		~KbfxPlasmaListBoxItem();
		virtual QString text();
		void setKbfxText(QString);
		virtual void paint(QPainter * p);
		void setId(uint i)
		{
		m_id = i;
		}
		uint id() { return m_id;}
		QString belongsTo(){ return m_parentName;}
		void setBelongsTo(QString name) { m_parentName = name;}
		void setIcon(QString path);
		void setMouseOver(bool s ) { m_mouseOver = s;}
		bool getState(){return m_mouseOver;}
		void setPos(int x , int y);
        virtual int height( const QListBox* ) const { return m_bgNormal.height();}
 

public slots:
	void mouseClicked(){}
signals:
	void raiseIt(uint); 	
protected:
	virtual int width( const QListBox* ) const { return m_bgNormal.width(); }
        //virtual int height( const QListBox* ) const { return m_bgNormal.height();}
	void loadIcon();

private:
	int m_id; //the value for corresponding Menu Stack
	QString m_name; //name of a given layer
	QString m_text;
	QString m_iconPath;
	QPixmap m_bgNormal;
	QPixmap m_bgHover;
        QPixmap m_icon;
	QString m_parentName;
	bool m_mouseOver;
	bool m_Clicked;
  	 int _x;
	int _y;	
	
};

#endif
